import requests
import json
import re
from urllib.parse import urlparse
import os

class DifyDoc:
    def __init__(self):
        self.auth_key = 'dataset-yJZrJiso0DNB1BHSNcg7U8GQ'
        self.api_url = "https://difytest.cloudclusters.net/v1/datasets"
        self.email = 'admin@gmail.com'
        self.password = "Def@ult4DBM"
        self.console_api = 'https://difytest.cloudclusters.net/console/api'

    def get_login_bearer_token(self):
        login_url = f"{self.console_api}/login"
        data = {
            'email': self.email,
            'password': self.password,
        }
        response = requests.post(login_url, json=data)
        if response.status_code != 200:
            raise Exception(f"Login failed: {response.status_code} - {response.text}")
        else:
            return response.json()['data']['access_token']
    def fetch_all_datasets(self):
        headers = {
            "Authorization": f"Bearer {self.auth_key}",
            "Content-Type": "application/json"
        }

        try:
            response = requests.get(self.api_url, headers=headers)

            if response.status_code == 200:
                return response.json().get('data', [])
            else:
                print(f"请求失败，状态码: {response.status_code}")
                return None
        except requests.RequestException as e:
            print(f"请求异常: {e}")
            return None

    def get_datasetid_by_name(self, name):
        datasets = self.fetch_all_datasets()
        if datasets:
            for dataset in datasets:
                if dataset['name'] == name:
                    return dataset['id']
        return None

    def get_all_documents(self, dataset_id='', page_size=1000):
        base_url = self.api_url + f"/{dataset_id}/documents"
        headers = {
            "Authorization": f"Bearer {self.auth_key}",
            "Content-Type": "application/json"
        }
        all_documents = []
        page = 1
        while True:
            params = {
                "limit": page_size,
                "page": page
            }
            try:
                response = requests.get(base_url, headers=headers, params=params)
                response.raise_for_status()
                data = response.json()
                documents = data.get("data", [])
                if not documents:
                    break
                all_documents.extend(documents)
                page += 1
            except requests.exceptions.RequestException as e:
                print(f"请求错误：{e}")
                break

        return all_documents

    def get_document_id_by_name(self, dataset_id, document_name):
        documents = self.get_all_documents(dataset_id)
        for document in documents:
            if document['name'] == document_name:
                return document["id"]

        return None

    def upload_document_segmentation(self, dataset_id="", bearer_token="", original_document_id="", data_file=""):
        url = self.console_api + f"/datasets/{dataset_id}/documents/{original_document_id}/segment"
        headers = {
            "authorization": f"Bearer {bearer_token}",
            "content-type": "application/json"
        }
        with open(data_file, 'r', encoding='utf-8') as f:
            content = f.read()
            sections = content.split('\n\n')
            for section in sections:
                payload = {
                    "content": section.replace('\n', '') 
                 }
                response = requests.post(url, headers=headers, data=json.dumps(payload))

if __name__ == "__main__":
    difyobj = DifyDoc()
    data_file = "solutions.txt"
    dataset_id = difyobj.get_datasetid_by_name("alantest")
    document_id = difyobj.get_document_id_by_name(dataset_id, data_file)
    barer_token = difyobj.get_login_bearer_token()
    difyobj.upload_document_segmentation(dataset_id=dataset_id, bearer_token=barer_token, original_document_id=document_id, data_file=data_file)
